Skip to content

serverExternalPackages

Opt-out specific dependencies from being included in the automatic bundling of the bundlePagesRouterDependencies option.

These pages will then use native Node.js require to resolve the dependency.

next.config.js
/** @type {import('next').NextConfig} */
const nextConfig = {
  serverExternalPackages: ['@acme/ui'],
}
 
module.exports = nextConfig

Next.js includes a short list of popular packages that currently are working on compatibility and automatically opt-ed out:

  • @appsignal/nodejs
  • @aws-sdk/client-s3
  • @aws-sdk/s3-presigned-post
  • @blockfrost/blockfrost-js
  • @highlight-run/node
  • @jpg-store/lucid-cardano
  • @libsql/client
  • @mikro-orm/core
  • @mikro-orm/knex
  • @node-rs/argon2
  • @node-rs/bcrypt
  • @prisma/client
  • @react-pdf/renderer
  • @sentry/profiling-node
  • @swc/core
  • argon2
  • autoprefixer
  • aws-crt
  • bcrypt
  • better-sqlite3
  • canvas
  • cpu-features
  • cypress
  • eslint
  • express
  • firebase-admin
  • isolated-vm
  • jest
  • jsdom
  • libsql
  • mdx-bundler
  • mongodb
  • mongoose
  • next-mdx-remote
  • next-seo
  • node-pty
  • node-web-audio-api
  • oslo
  • pg
  • playwright
  • playwright-core
  • postcss
  • prettier
  • prisma
  • puppeteer-core
  • puppeteer
  • rimraf
  • sharp
  • shiki
  • sqlite3
  • ts-node
  • ts-morph
  • typescript
  • vscode-oniguruma
  • webpack
  • websocket
  • zeromq